
Redmine - Feature #16941

Do not clear category on project change if category with same exists

2014-05-21 15:36 - Danil Tashkinov

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.2.0   

Resolution: Fixed   

Description

Category cleared when changing project for an issue.

Steps to reproduce:

1. There is a 'project1' with category 'some' and 'project2' with the same name category.

2. Create an issue in 'project1' and select 'some' category.

3. Open edit form for this issue.

4. Select 'project2'

Expected result:

The 'project2' has a category with the same name: 'some'. And we expect that the category will be 'some'.

Actually result:

The category field is empty.

Environment informationEnvironment information

$ ruby script/about

sh: darcs: command not found

sh: hg: command not found

sh: cvs: command not found

sh: bzr: command not found

Environment:

Redmine version                2.5.1.devel

Ruby version                   1.9.3-p448 (2013-06-27) [x86_64-darwin13.0.0]

Rails version                  3.2.18

Environment                    production

Database adapter               Mysql2

SCM:

Subversion                     1.7.10

Git                            1.8.4.2

Filesystem

Redmine plugins:

no plugin installed

Related issues:

Related to Redmine - Feature #5358: Share Issues Categories for sub-projects New 2010-04-20

Related to Redmine - Defect #19517: Copy issue with new project Closed

Associated revisions

Revision 14715 - 2015-10-20 20:57 - Jean-Philippe Lang

Do not clear category on project change if category with same exists (#16941).

History

#1 - 2014-06-18 07:40 - Toshi MARUYAMA

- Target version set to 2.6.0
#2 - 2014-06-18 07:42 - Toshi MARUYAMA

- Target version deleted (2.6.0)

#3 - 2014-06-18 07:48 - Toshi MARUYAMA

"Category" is depends on project.

Category ids not same even if category names are same.

I think clearing category is expected behavior.

#4 - 2014-06-18 07:52 - Toshi MARUYAMA

- Related to Feature #5358: Share Issues Categories for sub-projects added

#5 - 2014-09-06 04:18 - Jean-Baptiste Barth

- Status changed from New to Closed

I confirm, there's no point in having a different behaviour in the general case I think. If you want persistent values across projects then you'd better

use a custom field. If there's something lacking with custom field, tell us (maybe the ability to add a value from an issue for instance?). I close this

issue for now.

#6 - 2015-03-30 14:35 - Go MAEDA

- Related to Defect #19517: Copy issue with new project added

#7 - 2015-06-16 13:49 - Alexander Stehlik

I guess this is a bug because Redmine behaves inconsistently here: when you edit multiple issues and change the project, categories with the same

name will be preserved - see project setter for issues:

if category

    self.category = project.issue_categories.find_by_name(category.name)

end

 When you edit a single issue and you change the project, the category should not be cleared but should be set to a category with the same name (if

available).

#8 - 2015-06-16 15:00 - Alexander Stehlik

- File do_not_clear_category_on_project_change-2015-06-16-master.diff added

Rebased the patch to current master.

#9 - 2015-07-16 04:14 - Toshi MARUYAMA

- Status changed from Closed to New

- Target version set to 3.2.0

#10 - 2015-10-20 20:58 - Jean-Philippe Lang

- Tracker changed from Patch to Feature

- Subject changed from Do not clear category on project change to Do not clear category on project change if category with same exists

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

This is fixed in r14715. Slightly different fix, and test added.

Thanks for pointing this out.

Files

do_not_clear_category_on_project_change.diff 896 Bytes 2014-05-21 Danil Tashkinov

do_not_clear_category_on_project_change-2015-06-16-master.diff 573 Bytes 2015-06-16 Alexander Stehlik
